using Adaptation.Shared;
using Adaptation.Shared.Methods;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Reflection;
using System.Text.Json;

namespace _Tests.Extract.Staging.v2_36_3;

[TestClass]
public class BIORAD5
{

    private static CreateSelfDescription.Staging.v2_36_3.BIORAD5 _BIORAD5;

    [ClassInitialize]
    public static void ClassInitialize(TestContext testContext)
    {
        CreateSelfDescription.Staging.v2_36_3.BIORAD5.ClassInitialize(testContext);
        _BIORAD5 = CreateSelfDescription.Staging.v2_36_3.BIORAD5.EAFLoggingUnitTesting;
    }

    [TestMethod]
    public void Staging__v2_36_3__BIORAD5__txt() => _BIORAD5.Staging__v2_36_3__BIORAD5__txt();

    [TestMethod]
    public void Staging__v2_36_3__BIORAD5__Stratus() => _BIORAD5.Staging__v2_36_3__BIORAD5__Stratus();

    [TestMethod]
    public void Staging__v2_36_3__BIORAD5__Stratus637738592809956919__ReactorAndRDS()
    {
        DateTime dateTime;
        string check = "CassetteDataBioRad_*.txt";
        _BIORAD5.Staging__v2_36_3__BIORAD5__Stratus();
        MethodBase methodBase = new StackFrame().GetMethod();
        string[] variables = _BIORAD5.AdaptationTesting.GetVariables(methodBase, check);
        Tuple<string, string[], string[]> pdsf = Helpers.Metrology.GetLogisticsColumnsAndBody(variables[2], variables[4]);
        IFileRead fileRead = _BIORAD5.AdaptationTesting.Get(methodBase, sourceFileLocation: variables[2], sourceFileFilter: variables[3], useCyclicalForDescription: false);
        Tuple<string, Test[], JsonElement[], List<FileInfo>> extractResult = fileRead.ReExtract();
        Assert.IsFalse(string.IsNullOrEmpty(extractResult?.Item1));
        Assert.IsTrue(extractResult.Item3.Length > 0, "extractResult Array Length check!");
        Assert.IsNotNull(extractResult.Item4);
        Logistics logistics = new(fileRead);
        dateTime = Adaptation.FileHandlers.Stratus.ProcessData.GetDateTime(logistics, string.Empty);
        Assert.IsTrue(dateTime == logistics.DateTimeFromSequence);
        dateTime = Adaptation.FileHandlers.Stratus.ProcessData.GetDateTime(logistics, "11/24/21  08:39");
        Assert.IsTrue(dateTime == logistics.DateTimeFromSequence);
        Tuple<string, string[], string[]> pdsfNew = Helpers.Metrology.GetLogisticsColumnsAndBody(fileRead, logistics, extractResult, pdsf);
        Helpers.Metrology.CompareSave(variables[5], pdsf, pdsfNew);
        Assert.IsTrue(pdsf.Item1 == pdsfNew.Item1, "Item1 check!");
        string[] json = Helpers.Metrology.GetItem2(pdsf, pdsfNew);
        Helpers.Metrology.CompareSaveJSON(variables[5], json);
        Assert.IsTrue(json[0] == json[1], "Item2 check!");
        string[] join = Helpers.Metrology.GetItem3(pdsf, pdsfNew);
        Helpers.Metrology.CompareSaveTSV(variables[5], join);
        Assert.IsTrue(join[0] == join[1], "Item3 (Join) check!");
        Helpers.Metrology.UpdatePassDirectory(variables[2]);
    }

    [TestMethod]
    public void Staging__v2_36_3__BIORAD5__QS408M() => _BIORAD5.Staging__v2_36_3__BIORAD5__QS408M();

}

// dotnet build --runtime win-x64
// dotnet test --runtime win-x64 --no-build --filter "FullyQualifiedName~_Tests.Extract.Staging.v2_36_3" --% -- TestRunParameters.Parameter(name=\"Debug\", value=\"Debugger.IsAttached\")
// dotnet test --runtime win-x64 --no-build --filter "FullyQualifiedName~_Tests.Extract.Staging.v2_36_3 & ClassName~BIORAD5" --% -- TestRunParameters.Parameter(name=\"Debug\", value=\"Debugger.IsAttached\")
// dotnet test --runtime win-x64 --no-build --filter "FullyQualifiedName~_Tests.Extract.Staging.v2_36_3 & ClassName~BIORAD5 & Staging__v2_36_3__BIORAD5__Stratus637738592809956919__ReactorAndRDS" --% -- TestRunParameters.Parameter(name=\"Debug\", value=\"Debugger.IsAttached\")