using Adaptation.Shared;
using Adaptation.Shared.Methods;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Reflection;
using System.Text.Json;

namespace _Tests.Extract.Staging.v2_39_0;

[TestClass]
public class BIORAD4
{

    private static CreateSelfDescription.Staging.v2_39_0.BIORAD4 _BIORAD4;

    [ClassInitialize]
    public static void ClassInitialize(TestContext testContext)
    {
        CreateSelfDescription.Staging.v2_39_0.BIORAD4.ClassInitialize(testContext);
        _BIORAD4 = CreateSelfDescription.Staging.v2_39_0.BIORAD4.EAFLoggingUnitTesting;
    }

    [TestMethod]
    public void Staging__v2_39_0__BIORAD4__txt() => _BIORAD4.Staging__v2_39_0__BIORAD4__txt();

    [TestMethod]
    public void Staging__v2_39_0__BIORAD4__txt637730081979221342__Normal()
    {
        string check = "*DataBioRad.txt";
        _BIORAD4.Staging__v2_39_0__BIORAD4__txt();
        MethodBase methodBase = new StackFrame().GetMethod();
        string[] variables = _BIORAD4.AdaptationTesting.GetVariables(methodBase, check);

        _ = Helpers.Metrology.GetLogisticsColumnsAndBody(variables[2], variables[4]);
        IFileRead fileRead = _BIORAD4.AdaptationTesting.Get(methodBase, sourceFileLocation: variables[2], sourceFileFilter: variables[3], useCyclicalForDescription: false);

        _ = fileRead.ReExtract();
        Helpers.Metrology.UpdatePassDirectory(variables[2]);
    }

    [TestMethod]
    public void Staging__v2_39_0__BIORAD4__txt637746296480404920__Failure()
    {
        string check = "*DataBioRad.txt";
        _BIORAD4.Staging__v2_39_0__BIORAD4__txt();
        MethodBase methodBase = new StackFrame().GetMethod();
        string[] variables = _BIORAD4.AdaptationTesting.GetVariables(methodBase, check);

        _ = Helpers.Metrology.GetLogisticsColumnsAndBody(variables[2], variables[4]);
        IFileRead fileRead = _BIORAD4.AdaptationTesting.Get(methodBase, sourceFileLocation: variables[2], sourceFileFilter: variables[3], useCyclicalForDescription: false);

        _ = fileRead.ReExtract();
        Helpers.Metrology.UpdatePassDirectory(variables[2]);
    }

    [TestMethod]
    public void Staging__v2_39_0__BIORAD4__Stratus() => _BIORAD4.Staging__v2_39_0__BIORAD4__Stratus();

    [TestMethod]
    public void Staging__v2_39_0__BIORAD4__Stratus637730081979221342__RDS()
    {
        string check = "CassetteDataBioRad_*.txt";
        _BIORAD4.Staging__v2_39_0__BIORAD4__Stratus();
        MethodBase methodBase = new StackFrame().GetMethod();
        string[] variables = _BIORAD4.AdaptationTesting.GetVariables(methodBase, check);
        Tuple<string, string[], string[]> pdsf = Helpers.Metrology.GetLogisticsColumnsAndBody(variables[2], variables[4]);
        IFileRead fileRead = _BIORAD4.AdaptationTesting.Get(methodBase, sourceFileLocation: variables[2], sourceFileFilter: variables[3], useCyclicalForDescription: false);
        Tuple<string, Test[], JsonElement[], List<FileInfo>> extractResult = fileRead.ReExtract();
        Assert.IsFalse(string.IsNullOrEmpty(extractResult?.Item1));
        Assert.IsTrue(extractResult.Item3.Length > 0, "extractResult Array Length check!");
        Assert.IsNotNull(extractResult.Item4);
        Logistics logistics = new(fileRead);
        Tuple<string, string[], string[]> pdsfNew = Helpers.Metrology.GetLogisticsColumnsAndBody(fileRead, logistics, extractResult, pdsf);
        Helpers.Metrology.CompareSave(variables[5], pdsf, pdsfNew);
        Assert.IsTrue(pdsf.Item1 == pdsfNew.Item1, "Item1 check!");
        string[] json = Helpers.Metrology.GetItem2(pdsf, pdsfNew);
        Helpers.Metrology.CompareSaveJSON(variables[5], json);
        Assert.IsTrue(json[0] == json[1], "Item2 check!");
        string[] join = Helpers.Metrology.GetItem3(pdsf, pdsfNew);
        Helpers.Metrology.CompareSaveTSV(variables[5], join);
        Assert.IsTrue(join[0] == join[1], "Item3 (Join) check!");
        Helpers.Metrology.UpdatePassDirectory(variables[2]);
    }

    [TestMethod]
    public void Staging__v2_39_0__BIORAD4__Stratus637730081979221342__1TRDS()
    {
        string check = "CassetteDataBioRad_*.txt";
        _BIORAD4.Staging__v2_39_0__BIORAD4__Stratus();
        MethodBase methodBase = new StackFrame().GetMethod();
        string[] variables = _BIORAD4.AdaptationTesting.GetVariables(methodBase, check);
        Tuple<string, string[], string[]> pdsf = Helpers.Metrology.GetLogisticsColumnsAndBody(variables[2], variables[4]);
        IFileRead fileRead = _BIORAD4.AdaptationTesting.Get(methodBase, sourceFileLocation: variables[2], sourceFileFilter: variables[3], useCyclicalForDescription: false);
        Tuple<string, Test[], JsonElement[], List<FileInfo>> extractResult = fileRead.ReExtract();
        Assert.IsFalse(string.IsNullOrEmpty(extractResult?.Item1));
        Assert.IsTrue(extractResult.Item3.Length > 0, "extractResult Array Length check!");
        Assert.IsNotNull(extractResult.Item4);
        Logistics logistics = new(fileRead);
        Tuple<string, string[], string[]> pdsfNew = Helpers.Metrology.GetLogisticsColumnsAndBody(fileRead, logistics, extractResult, pdsf);
        Helpers.Metrology.CompareSave(variables[5], pdsf, pdsfNew);
        Assert.IsTrue(pdsf.Item1 == pdsfNew.Item1, "Item1 check!");
        string[] json = Helpers.Metrology.GetItem2(pdsf, pdsfNew);
        Helpers.Metrology.CompareSaveJSON(variables[5], json);
        Assert.IsTrue(json[0] == json[1], "Item2 check!");
        string[] join = Helpers.Metrology.GetItem3(pdsf, pdsfNew);
        Helpers.Metrology.CompareSaveTSV(variables[5], join);
        Assert.IsTrue(join[0] == join[1], "Item3 (Join) check!");
        Helpers.Metrology.UpdatePassDirectory(variables[2]);
    }

    [TestMethod]
    public void Staging__v2_39_0__BIORAD4__Stratus637733400573863329__ReactorAndRDS()
    {
        DateTime dateTime;
        string check = "CassetteDataBioRad_*.txt";
        _BIORAD4.Staging__v2_39_0__BIORAD4__Stratus();
        MethodBase methodBase = new StackFrame().GetMethod();
        string[] variables = _BIORAD4.AdaptationTesting.GetVariables(methodBase, check);
        Tuple<string, string[], string[]> pdsf = Helpers.Metrology.GetLogisticsColumnsAndBody(variables[2], variables[4]);
        IFileRead fileRead = _BIORAD4.AdaptationTesting.Get(methodBase, sourceFileLocation: variables[2], sourceFileFilter: variables[3], useCyclicalForDescription: false);
        Tuple<string, Test[], JsonElement[], List<FileInfo>> extractResult = fileRead.ReExtract();
        Assert.IsFalse(string.IsNullOrEmpty(extractResult?.Item1));
        Assert.IsTrue(extractResult.Item3.Length > 0, "extractResult Array Length check!");
        Assert.IsNotNull(extractResult.Item4);
        Logistics logistics = new(fileRead);
        dateTime = Adaptation.FileHandlers.Stratus.ProcessData.GetDateTime(logistics, string.Empty);
        Assert.IsTrue(dateTime == logistics.DateTimeFromSequence);
        dateTime = Adaptation.FileHandlers.Stratus.ProcessData.GetDateTime(logistics, "11/24/21  08:39");
        Assert.IsTrue(dateTime == logistics.DateTimeFromSequence);
        Tuple<string, string[], string[]> pdsfNew = Helpers.Metrology.GetLogisticsColumnsAndBody(fileRead, logistics, extractResult, pdsf);
        Helpers.Metrology.CompareSave(variables[5], pdsf, pdsfNew);
        Assert.IsTrue(pdsf.Item1 == pdsfNew.Item1, "Item1 check!");
        string[] json = Helpers.Metrology.GetItem2(pdsf, pdsfNew);
        Helpers.Metrology.CompareSaveJSON(variables[5], json);
        Assert.IsTrue(json[0] == json[1], "Item2 check!");
        string[] join = Helpers.Metrology.GetItem3(pdsf, pdsfNew);
        Helpers.Metrology.CompareSaveTSV(variables[5], join);
        Assert.IsTrue(join[0] == join[1], "Item3 (Join) check!");
        Helpers.Metrology.UpdatePassDirectory(variables[2]);
    }

    [TestMethod]
    public void Staging__v2_39_0__BIORAD4__QS408M() => _BIORAD4.Staging__v2_39_0__BIORAD4__QS408M();

}