using System.Collections.Generic;
using Ifx.Eaf.EquipmentConnector.File.Component;
using Ifx.Eaf.EquipmentConnector.File.Configuration;

namespace Shared
{

    public class FilePathGenerator : Ifx.Eaf.EquipmentConnector.File.Component.FilePathGenerator
    {

        public FileConnectorConfiguration FileConnectorConfiguration { get; private set; }

        public FilePathGenerator(FileConnectorConfiguration config, Dictionary<string, string> customPattern = null) : base(config, customPattern)
        {
            FileConnectorConfiguration = config;
        }

        public FilePathGenerator(FileConnectorConfiguration config, File file, bool isErrorFile = false, Dictionary<string, string> customPattern = null) : base(config, file, isErrorFile, customPattern)
        {
            FileConnectorConfiguration = config;
        }

        public FilePathGenerator(FileConnectorConfiguration config, string sourceFilePath, bool isErrorFile = false, Dictionary<string, string> customPattern = null) : base(config, sourceFilePath, isErrorFile, customPattern)
        {
            FileConnectorConfiguration = config;
        }

        public string GetSubFolderPath()
        {
            return SubFolderPath;
        }

    }

}
